(function () {
  "use strict";

  var namespace = require('ns3');

  var express = require('express');
  var path = require('path');
  var namespace = require('ns3');
  var passport = require('passport');
  var BasicStrategy = require('passport-http').BasicStrategy;

  var routes = namespace('express.routes.index');
  var routesGet = namespace('express.routes.get');

  // Базовая авторизация
  passport.use(new BasicStrategy(
      function (username, password, done) {
        var users = namespace('app.config').get('users');
        if (users && users.hasOwnProperty(username) && users[username] === password) {
          return done(null, username);
        } else {
          return done(null, false);
        }
      }
  ));

  var app = express();
  app.disable('x-powered-by');
  app.set('view engine', 'jade');
  app.set('views', path.join(__dirname, 'views'));
  app.use(express['static'](path.join(__dirname, 'public')));

  app.use('/', routes);
  app.use('/get', routesGet);

  // catch 404 and forward to error handler
  app.use(function (req, res, next) {
    var err = new Error('Not Found');
    err.status = 404;
    next(err);
  });

  // error handlers

  // development error handler
  // will print stacktrace
  if (app.get('env') === 'development') {
    app.use(function (err, req, res, next) {
      res.status(err.status || 500);
      res.render('error', {
        message: err.message,
        error: err
      });
    });
  }

  // production error handler
  // no stacktraces leaked to user
  app.use(function (err, req, res, next) {
    res.status(err.status || 500);
    res.render('error', {
      message: err.message,
      error: {}
    });
  });

  namespace('express.app', app);

})();