(function () {
  "use strict";

  var namespace = require('ns3');
  var express = require('express');
  var router = express.Router();
  var passport = require('passport');
  var authRequired = passport.authenticate('basic', {session: false});
  var projectHelper = namespace('app.libs.projectHelper');
  var md5 = require('md5');
  
  router.get('/', function (req, res) {
    res.send('Use link as "https://admin:admin@localhost:3000/get/project-name/" (with basic auth)');
  });

  // https://admin:admin@localhost:3000/get/1234567/test111, 1234567 - cache_id, test111 - project name
  router.get(/^\/([^\/]+)\/?(.*)/, authRequired, function (req, res, next) {
    var project = req.params[0];
    var file = req.params[1];
    if (!file) {
      file = '';
    }
    var cache_id = md5(req.ip);
    
    // Проверка доступа пользователя к этому проэкту
    var access = namespace('app.config').get('projects.'+project+'.access');
    if (access) {
      var isAllow1 = typeof access === 'string' && access === req.user;
      var isAllow2 = typeof access === 'object' && access.indexOf(req.user) !== -1;
      if (!(isAllow1 || isAllow2)) {
        return res.status(403).send('403. You do not have access to this project.');
      }
    } else {
      return res.status(500).send('500. Access rules not found.');
    }
    
    if (!cache_id) {
      return res.status(403).send('403. Random cache ID required.');
    }
    
    projectHelper.get(res, project, file, cache_id);
  });

  namespace('express.routes.get', router);

})();
