/**
 * Импорт необходимых файлов
 */

var importjs = {
  /**
   * Список файлов для подключения
   * @type Array
   */
  _files: [
    'libs/Config.js',
    'app.init.config.js',
    'libs/ConsoleScript.js',
    'libs/sendFilesHelper',
    'libs/projectHelper',
    
    'express/routes/index.js',
    'express/routes/get.js',
    'express/app.js'
  ],
  getEnv: function () {
    var env = typeof process.env.NODE_ENV === 'string'
        ? process.env.NODE_ENV.trim()
        : process.env.NODE_ENV;
    if (!env === 'development') {
      env = 'production';
    }
    return env;
  },
  files: function (env, prefix) {
    env = env ? env : this.getEnv();
    prefix = prefix ? prefix : './';
    var files = [];
    for (var key in this._files) {
      var value = this._files[key];
      if (value && typeof value === 'string') {
        files.push(prefix + value);
      } else if (typeof value === 'object') {
        var allowedEnv = value.env;
        if (allowedEnv) {
          if (typeof allowedEnv === 'string' && allowedEnv === env) {
            files.push(prefix + value.path);
          } else if (typeof allowedEnv === 'object' && allowedEnv.indexOf(env) !== -1) {
            files.push(prefix + value.path);
          }
        }
      } else {
        console.warn('Warning (importjs): invalid key type:', typeof value);
      }
    }
    return files;
  },
  run: function (env) {
    var files = this.files();
    for (var key in files) {
      var path = files[key];
      if (path) {
        require(path);
      }
    }
  }

};

module.exports = importjs;