var namespace = require('ns3');
var debug = require('debug')('myapp:server');
var http = require('http');

// Import app files
var importjs = require('./app/import.js');
importjs.run();

var expressApp = namespace('express.app');
var port = namespace('app.config').get('express.port');
port = port ? port : 3000;

var server = http.createServer(expressApp);
server.listen(port, function(){
  console.log('........SERVER LISTEN PORT ..................................... '+port);
});
server.on('error', onError);
server.on('listening', onListening);

/**
 * Event listener for HTTP server "error" event.
 */

function onError(error) {
  if (error.syscall !== 'listen') {
    throw error;
  }

  var bind = typeof port === 'string'
    ? 'Pipe ' + port
    : 'Port ' + port;

  // handle specific listen errors with friendly messages
  switch (error.code) {
    case 'EACCES':
      console.error(bind + ' requires elevated privileges');
      process.exit(1);
      break;
    case 'EADDRINUSE':
      console.error(bind + ' is already in use');
      process.exit(1);
      break;
    default:
      throw error;
  }
}

/**
 * Event listener for HTTP server "listening" event.
 */

function onListening() {
  var addr = server.address();
  var bind = typeof addr === 'string'
    ? 'pipe ' + addr
    : 'port ' + addr.port;
  debug('Listening on ' + bind);
}
